//
// ContactListings.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct ContactListings: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var agentNotesUnreadYN: Bool?
    public var contactNotesUnreadYN: Bool?
    public var directEmailYN: Bool?
    public var listingViewedYN: Bool?
    public var contactKeyNumeric: Double?
    public var contactListingsKeyNumeric: Double?
    public var listingKeyNumeric: Double?
    public var contactKey: String?
    public var contactListingsKey: String?
    public var contactLoginId: String?
    public var listingId: String?
    public var listingKey: String?
    public var className: String?
    public var contactListingPreference: String?
    public var resourceName: String?
    public var lastAgentNoteTimestamp: Date?
    public var lastContactNoteTimestamp: Date?
    public var listingModificationTimestamp: Date?
    public var listingSentTimestamp: Date?
    public var modificationTimestamp: Date?
    public var portalLastVisitedTimestamp: Date?
    public var contact: Contacts?
    public var property: Property?

    public init(id: Int? = nil, agentNotesUnreadYN: Bool? = nil, contactNotesUnreadYN: Bool? = nil, directEmailYN: Bool? = nil, listingViewedYN: Bool? = nil, contactKeyNumeric: Double? = nil, contactListingsKeyNumeric: Double? = nil, listingKeyNumeric: Double? = nil, contactKey: String? = nil, contactListingsKey: String? = nil, contactLoginId: String? = nil, listingId: String? = nil, listingKey: String? = nil, className: String? = nil, contactListingPreference: String? = nil, resourceName: String? = nil, lastAgentNoteTimestamp: Date? = nil, lastContactNoteTimestamp: Date? = nil, listingModificationTimestamp: Date? = nil, listingSentTimestamp: Date? = nil, modificationTimestamp: Date? = nil, portalLastVisitedTimestamp: Date? = nil, contact: Contacts? = nil, property: Property? = nil) {
        self.id = id
        self.agentNotesUnreadYN = agentNotesUnreadYN
        self.contactNotesUnreadYN = contactNotesUnreadYN
        self.directEmailYN = directEmailYN
        self.listingViewedYN = listingViewedYN
        self.contactKeyNumeric = contactKeyNumeric
        self.contactListingsKeyNumeric = contactListingsKeyNumeric
        self.listingKeyNumeric = listingKeyNumeric
        self.contactKey = contactKey
        self.contactListingsKey = contactListingsKey
        self.contactLoginId = contactLoginId
        self.listingId = listingId
        self.listingKey = listingKey
        self.className = className
        self.contactListingPreference = contactListingPreference
        self.resourceName = resourceName
        self.lastAgentNoteTimestamp = lastAgentNoteTimestamp
        self.lastContactNoteTimestamp = lastContactNoteTimestamp
        self.listingModificationTimestamp = listingModificationTimestamp
        self.listingSentTimestamp = listingSentTimestamp
        self.modificationTimestamp = modificationTimestamp
        self.portalLastVisitedTimestamp = portalLastVisitedTimestamp
        self.contact = contact
        self.property = property
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case agentNotesUnreadYN = "AgentNotesUnreadYN"
        case contactNotesUnreadYN = "ContactNotesUnreadYN"
        case directEmailYN = "DirectEmailYN"
        case listingViewedYN = "ListingViewedYN"
        case contactKeyNumeric = "ContactKeyNumeric"
        case contactListingsKeyNumeric = "ContactListingsKeyNumeric"
        case listingKeyNumeric = "ListingKeyNumeric"
        case contactKey = "ContactKey"
        case contactListingsKey = "ContactListingsKey"
        case contactLoginId = "ContactLoginId"
        case listingId = "ListingId"
        case listingKey = "ListingKey"
        case className = "ClassName"
        case contactListingPreference = "ContactListingPreference"
        case resourceName = "ResourceName"
        case lastAgentNoteTimestamp = "LastAgentNoteTimestamp"
        case lastContactNoteTimestamp = "LastContactNoteTimestamp"
        case listingModificationTimestamp = "ListingModificationTimestamp"
        case listingSentTimestamp = "ListingSentTimestamp"
        case modificationTimestamp = "ModificationTimestamp"
        case portalLastVisitedTimestamp = "PortalLastVisitedTimestamp"
        case contact = "Contact"
        case property = "Property"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(agentNotesUnreadYN, forKey: .agentNotesUnreadYN)
        try container.encodeIfPresent(contactNotesUnreadYN, forKey: .contactNotesUnreadYN)
        try container.encodeIfPresent(directEmailYN, forKey: .directEmailYN)
        try container.encodeIfPresent(listingViewedYN, forKey: .listingViewedYN)
        try container.encodeIfPresent(contactKeyNumeric, forKey: .contactKeyNumeric)
        try container.encodeIfPresent(contactListingsKeyNumeric, forKey: .contactListingsKeyNumeric)
        try container.encodeIfPresent(listingKeyNumeric, forKey: .listingKeyNumeric)
        try container.encodeIfPresent(contactKey, forKey: .contactKey)
        try container.encodeIfPresent(contactListingsKey, forKey: .contactListingsKey)
        try container.encodeIfPresent(contactLoginId, forKey: .contactLoginId)
        try container.encodeIfPresent(listingId, forKey: .listingId)
        try container.encodeIfPresent(listingKey, forKey: .listingKey)
        try container.encodeIfPresent(className, forKey: .className)
        try container.encodeIfPresent(contactListingPreference, forKey: .contactListingPreference)
        try container.encodeIfPresent(resourceName, forKey: .resourceName)
        try container.encodeIfPresent(lastAgentNoteTimestamp, forKey: .lastAgentNoteTimestamp)
        try container.encodeIfPresent(lastContactNoteTimestamp, forKey: .lastContactNoteTimestamp)
        try container.encodeIfPresent(listingModificationTimestamp, forKey: .listingModificationTimestamp)
        try container.encodeIfPresent(listingSentTimestamp, forKey: .listingSentTimestamp)
        try container.encodeIfPresent(modificationTimestamp, forKey: .modificationTimestamp)
        try container.encodeIfPresent(portalLastVisitedTimestamp, forKey: .portalLastVisitedTimestamp)
        try container.encodeIfPresent(contact, forKey: .contact)
        try container.encodeIfPresent(property, forKey: .property)
    }
}

